"use strict";

exports.__esModule = true;
exports.default = void 0;

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_debug.default.formatters.i = ctx => {
  const stringifiedInfoArr = [];
  const contentInfo = ctx.contentInfo;
  if (ctx.isPage) stringifiedInfoArr.push('isPage');
  if (ctx.isIframe) stringifiedInfoArr.push('isIframe');
  if (ctx.isAjax) stringifiedInfoArr.push('isAjax');
  if (ctx.isWebSocket) stringifiedInfoArr.push('isWebSocket');
  if (contentInfo.isCSS) stringifiedInfoArr.push('isCSS');
  if (contentInfo.isScript) stringifiedInfoArr.push('isScript');
  if (contentInfo.isManifest) stringifiedInfoArr.push('isManifest');
  if (contentInfo.isFileDownload) stringifiedInfoArr.push('isFileDownload');
  if (contentInfo.isNotModified) stringifiedInfoArr.push('isNotModified');
  if (contentInfo.isRedirect) stringifiedInfoArr.push('isRedirect');
  if (contentInfo.isIframeWithImageSrc) stringifiedInfoArr.push('isIframeWithImageSrc');
  if (contentInfo.charset) stringifiedInfoArr.push('charset: ' + contentInfo.charset.get());
  stringifiedInfoArr.push('encoding: ' + contentInfo.encoding);
  stringifiedInfoArr.push('requireProcessing: ' + contentInfo.requireProcessing);
  return `{ ${stringifiedInfoArr.join(', ')} }`;
};

const hammerhead = (0, _debug.default)('hammerhead');
const proxy = hammerhead.extend('proxy');
const destination = hammerhead.extend('destination');
const destinationSocket = destination.extend('socket');
const serviceMsg = hammerhead.extend('service-message');
var _default = {
  proxy,
  destination,
  destinationSocket,
  serviceMsg
};
exports.default = _default;
module.exports = exports.default;